<?php

/**
 * The file that defines the core plugin class
 *
 * A class definition that includes attributes and functions used across both the
 * public-facing side of the site and the admin area.
 *
 * @link       https://wpconfiguratorbuilder.com/
 * @since      1.0.0
 *
 * @package    wcb-configurator-builder
 * @subpackage wcb-configurator-builder/includes
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

/**
 * The core plugin class.
 *
 * This is used to define internationalization, admin-specific hooks, and
 * public-facing site hooks.
 *
 * Also maintains the unique identifier of this plugin as well as the current
 * version of the plugin.
 *
 * @since      1.0.0
 * @package    wcb-configurator-builder
 * @subpackage wcb-configurator-builder/includes
 * @author     WPCB <support@wpconfiguratorbuilder.com>
 */
class WPCB {

	/**
	 * The loader that's responsible for maintaining and registering all hooks that power
	 * the plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      WPCB_Loader    $loader    Maintains and registers all hooks for the plugin.
	 */
	protected $loader;

	/**
	 * The unique identifier of this plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $plugin_name    The string used to uniquely identify this plugin.
	 */
	protected $plugin_name;

	/**
	 * The current version of the plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $version    The current version of the plugin.
	 */
	protected $version;

	/**
	 * Define the core functionality of the plugin.
	 *
	 * Set the plugin name and the plugin version that can be used throughout the plugin.
	 * Load the dependencies, define the locale, and set the hooks for the admin area and
	 * the public-facing side of the site.
	 *
	 * @since    1.0.0
	 */
	public function __construct() {
		if ( defined( 'WPCB_VERSION' ) ) {
			$this->version = WPCB_VERSION;
		} else {
			$this->version = '1.0.0';
		}
		$this->plugin_name = 'wpcb';

		$this->load_dependencies();
		$this->define_core_hooks();
		$this->define_admin_hooks();
		$this->define_public_hooks();
	}

	/**
	 * Load the required dependencies for this plugin.
	 *
	 * Include the following files that make up the plugin:
	 *
	 * - WPCB_Loader. Orchestrates the hooks of the plugin.
	 * - WPCB_i18n. Defines internationalization functionality.
	 * - WPCB_Admin. Defines all hooks for the admin area.
	 * - WPCB_Public. Defines all hooks for the public side of the site.
	 *
	 * Create an instance of the loader which will be used to register the hooks
	 * with WordPress.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function load_dependencies() {

		/**
		 * The class responsible for orchestrating the actions and filters of the
		 * core plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'admin/wpcb-admin-functions.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/wpcb-functions.php';

		/**
		 * The class responsible for defining the admin fields functionality
		 * of the plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'vendor/carbon-fields/carbon-fields-plugin.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-wpcb-fields.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-wpcb-i18n.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-wpcb-formatter.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-wpcb-shortcodes.php';

		/**
		 * The classes responsible for defining all actions that occur in the admin area.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'admin/class-wpcb-admin.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'admin/class-wpcb-admin-order.php';
		
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'admin/class-wpcb-settings.php';

		/**
		 * The class responsible for defining the admin fields functionality
		 * of the plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/posts/class-wpcb-configuration.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/posts/class-wpcb-choice.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/posts/class-wpcb-input.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/posts/class-wpcb-visual.php';

		/**
		 * The classes responsible for defining all WooCommerce related actions.
		 */

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/woocommerce/class-wpcb-product.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/woocommerce/class-wpcb-cart.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/woocommerce/class-wpcb-quote.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/woocommerce/class-wpcb-order.php';

		/**
		 * The class responsible for defining all actions that occur in the public-facing
		 * side of the site.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'public/class-wpcb-public.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'public/wpcb-template-functions.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'public/wpcb-template-hooks.php';

	}

	/**
	 * Register all of the hooks related to both the admin area and public-facing functionality
	 * of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_core_hooks() {

		/**
		 * Core hooks.
		 */
		$plugin_fields = new WPCB_Fields();

		$plugin_builder = new WPCB_Configuration( $this->get_version() );
		$plugin_choice = new WPCB_Choice();
		$plugin_input = new WPCB_Input();
		$plugin_visual = new WPCB_Visual();

		$plugin_wc_product = new WPCB_WC_Product();
		$plugin_wc_cart = new WPCB_Cart();
		$plugin_wc_quote = new WPCB_Quote();
		$plugin_wc_order = new WPCB_Order();

		$plugin_i18n = new WPCB_i18n();
		
	}

	/**
	 * Register all of the hooks related to the admin area functionality
	 * of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_admin_hooks() {

		/**
		 * Admin hooks.
		 */

		$plugin_admin = new WPCB_Admin( $this->get_plugin_name(), $this->get_version() );

		$plugin_admin_order = new WPCB_Admin_Order();

		$plugin_settings = new WPCB_Settings();

	}

	/**
	 * Register all of the hooks related to the public-facing functionality
	 * of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_public_hooks() {

		/**
		 * Plugin Public hooks.
		 */

		$plugin_public = new WPCB_Public( $this->get_plugin_name(), $this->get_version() );

		$plugin_shortcodes = new WPCB_Shortcodes();

	}

	/**
	 * The name of the plugin used to uniquely identify it within the context of
	 * WordPress and to define internationalization functionality.
	 *
	 * @since     1.0.0
	 * @return    string    The name of the plugin.
	 */
	public function get_plugin_name() {
		return $this->plugin_name;
	}

	/**
	 * The reference to the class that orchestrates the hooks with the plugin.
	 *
	 * @since     1.0.0
	 * @return    WPCB_Loader    Orchestrates the hooks of the plugin.
	 */
	public function get_loader() {
		return $this->loader;
	}

	/**
	 * Retrieve the version number of the plugin.
	 *
	 * @since     1.0.0
	 * @return    string    The version number of the plugin.
	 */
	public function get_version() {
		return $this->version;
	}
}
